freeslot("SPR_CLPE")
--World's REDACTED SRB2P Supported Character!

if not srb2p return end

-- Define our base character's stats!
charStats["cman"] = {

		-- GENERAL

		name = "cman",		-- This is only for bots / enemies
		basehp = 68,			-- base HP for level 1 (Cannot be <= 0)
		basesp = 18,			-- base SP for level 1 (Can be 0, but not < 0!)
		persona = "cman",		-- Persona to use
		melee_natk = "metal_atk1",	-- normal melee attack

		
		
		atk = 40,	-- power (generally < 50)
		acc = 95,	-- accuracy (%)
		crit = 2,	-- crit rate (%)

		



		anim_stand = 		{SPR_PLAY, A, 8, "SPR2_STND"},					-- standing
		anim_stand_hurt =	{SPR_PLAY, A, 1, "SPR2_STND"},					-- standing (low HP) *
		anim_stand_bored =	{SPR_PLAY, A, 8, "SPR2_STND"},					-- standing (occasionally plays after anim_stand has played several times)
		anim_guard = 		{SPR_PLAY, A, 1, "SPR2_GARD"},					-- guarding
		anim_move =			{SPR_PLAY, A, B, C, D, E, F, 2, "SPR2_WALK"},	-- moving
		anim_run =			{SPR_PLAY, A, B, C, D, E, F, 2, "SPR2_WALK"},	-- guess what
		anim_atk =			{SPR_PLAY, A, B, C, D, 2, "SPR2_ROLL"},			-- attacking
		anim_aoa_end =		{SPR_PLAY, D, C, B, A, 2, "SPR2_ROLL"},			-- jumping out of all-out attack
		anim_hurt =			{SPR_PLAY, A, 35, "SPR2_DEAD"},					-- taking damage
		anim_getdown =		{SPR_PLAY, A, 1, "SPR2_CNT1"},					-- knocked down from weakness / crit *
		anim_downloop =		{SPR_PLAY, A, 1, "SPR2_CNT1"},					-- is down
		anim_getup =		{SPR_PLAY, A, B, C, D, 1, "SPR2_ROLL"},			-- gets up from down
		anim_death =		{SPR_PLAY, A, 30, "SPR2_PAIN"},					-- dies
		anim_revive =		{SPR_PLAY, A, B, C, D, 1, "SPR2_ROLL"},			-- gets revived
		anim_evoker =		{SPR_CLPE, A, B, 2},	
		anim_evoker_shoot =	{SPR_CLPE, C, 2},		
		
		anim_special1 = {SPR_PLAY, A, B, C, D, 2, "SPR2_SKID"}, 
		anim_special2 = {SPR_PLAY, A, B, C, D, 1, "SPR2_SKID"}, 
		
		
		anim_special1 =		{SPR_PLAY, A, TICRATE, "SPR2_MLEE"},
		anim_special4 = 	{SPR_PLAY, A, TICRATE, "SPR2_GARD"},			
		anim_sepcial5 =		{SPR_PLAY, A, TICRATE, "SPR2_HOWP"},			
		anim_special6 =		{SPR_PLAY, A, B, 2, "SPR2_HOWL"},				


		icon = "ICO_CMAN",			-- head icon for character select
		hudbust = "H_CMNBAR",			-- patch to draw on the stat hud
		hudaoa = "H_CMNAOA",		-- patch for all out attack hud
		aoa_quote = "I may be smaller but\nbut i am stronger!",
		hudcutin = "CMAN_A",		-- cut in frames prefix


	
		tip = "Cman specializes as an strike player\nhe takes good damage!\nhowever he's strong.",
}


personaList["cman"] = {
		-- GENERAL
		name = "cman",	
		arcana = nil,			

		sprite = SPR_PSN0,		
		startframe = 0,			

		-- Animations function the same way they do for players. (In cman's case, she's so good she doesn't need one, so let's make it invisible)
		anim_idle = 	{SPR_NULL, A},	-- Idle animation when summoned in the menu
		anim_atk = 		{SPR_NULL, A},	-- Animation when attacking

		-- Stats (at level 10)
		-- Remember that stats naturally cap at 99.
		strength = 10,
		magic = 7,
		endurance = 4,
		luck = 9,
		agility = 13,

		-- Affinities (weak, resist, block, drain)
		weak = ATK_CURSE,
		resist = ATK_SLASH|ATK_BLESS,
		block = ATK_PIERCE,

		skills = {
					{"sonic punch", 1}, {"abysmal surge", 1},
					{"god hand", 12}, {"assault dive", 16},
					{"reseist strike", 20}, {"survivival trick", 24},
					{"gale slash", 27}, {"tempest slash", 29},

					{"survive death", 34, "infinite endure"},
					{"regenerate 3", 40, "sonic punch"},
					{"terror voice", 43, "poison mist"},
					{"psiodyne", 46, "giant slice"},
					{"fatal end", 50, "brave blade"},

					{"akasha arts", 54, "mapsiodyne"},
					{"kougaon", 56, "makougaon"},
					{"eigaon", 58, "freidyne"},
					{"ziodyne", 60, "elec break"},
					{"super", 64, "super"},

					{"brave blade", 73, "fatal end"},
				},
}

-- Finally, let us define our additional skills.

attackDefs	["super"] = {	-- skill used to activate super form
		name = "Super Form",
		type = ATK_ALMIGHTY,
		power = 0,
		accuracy = 0,
		costtype = CST_SP,
		cost = 0,
		desc = "Cman Turns Super.\nBut Will He?.",
		target = TGT_CASTER,
		anim =	function(mo, targets, hittargets, timer)

					if timer >= TICRATE*2/3
						mo.momz = $*90/100
					elseif timer >= 1
						mo.momz = FRACUNIT
						mo.flags = $|MF_NOGRAVITY	-- lol
					end

					if timer == 1

						local cx = mo.x + 256*cos(mo.angle + ANG1*20)
						local cy = mo.y + 256*sin(mo.angle + ANG1*20)
						CAM_goto(server.P_BattleStatus[mo.battlen].cam, cx, cy, mo.z + FRACUNIT*30, 70*FRACUNIT)
						CAM_angle(server.P_BattleStatus[mo.battlen].cam, R_PointToAngle2(cx, cy, mo.x, mo.y))

						mo.anim = nil	-- kind of a hack
						mo.state = S_PLAY_FALL
					end

					-- spawn the emeralds:
					if timer == TICRATE/2
						mo.emeralds = {}
						mo.em_rotspeed = 1
						mo.em_ang = 0
						mo.em_dist = 1024

						for i = 1, 7
							mo.emeralds[i] = P_SpawnMobj(0, 0, 0, MT_EMERALD1+(i-1))
							mo.emeralds[i].scale = $*3/2
						end
					end

					if timer >= TICRATE/2
					and mo.emeralds and mo.emeralds[1] and mo.emeralds[1].valid


						local ang = mo.em_ang
						for i = 1, 7
							local x = mo.x + mo.em_dist*cos(ang)
							local y = mo.y + mo.em_dist*sin(ang)
							local z = mo.z + 32*cos(leveltime*ANG1*2 + (360/7)*ANG1*i)	-- funny z axis variation

							P_TeleportMove(mo.emeralds[i], x, y, z)
							ang = $ + (360/7)*ANG1
						end

						mo.em_ang = $+ mo.em_rotspeed*ANG1
						mo.em_rotspeed = min(32, $+1)
						mo.em_dist = max(64, $-24)
					end

					if timer == TICRATE*2
						for i = 1, 7 do
							P_RemoveMobj(mo.emeralds[i])
						end
						mo.emeralds = nil

						mo.state = S_PLAY_SUPER_TRANS1
						for k,v in ipairs(mo.allies)
							if v and v.control and v.control.valid
								P_FlashPal(v.control, 1, 8)
							end
						end
						S_StartSound(mo, sfx_s3k9f)
						mo.status_condition = COND_SUPER	-- direct affectation
					end

					if timer >= TICRATE*2
						if mo.state == S_PLAY_SUPER_TRANS6
							mo.tics = -1
						end
					end

					if timer == TICRATE*3 + TICRATE/2
						mo.z = mo.floorz
						mo.flags = $ & ~MF_NOGRAVITY
						return true	-- actually fuck that
					end
					/*
					if mo.waitforground and P_IsObjectOnGround(mo)
						ANIM_set(mo, mo.anim_stand)
						mo.waitforground = nil
					end

					if timer == TICRATE*4 + TICRATE/2
						return true
					end*/
				end,
}

VFX_freeslotC("cman")