//Cman code by SMS Alfredo

local PREPTIME = TICRATE/2
local CLOUDTIME = 16
local SQUISHTIME = 6

sfxinfo[freeslot("sfx_cmcld1")].caption = "Cloud spawn"
sfxinfo[freeslot("sfx_cmcld2")].caption = "Cloud jump"

sfxinfo[freeslot("sfx_cmdsmd")].caption = "Lose Light mode"

sfxinfo[freeslot("sfx_cmprep")].caption = "Prepping"
sfxinfo[freeslot("sfx_cmdash")].caption = "Dash"
sfxinfo[freeslot("sfx_cmwind")].caption = "/"

sfxinfo[freeslot("sfx_cmmtl1")].caption = "/"
sfxinfo[freeslot("sfx_cmmtl2")].caption = "/"

freeslot("SPR_CMN1", "S_CMAN_PARTICLE2", "SPR_CMN2")
states[S_CMAN_PARTICLE2] = {SPR_CMN2, A|FF_ANIMATE, (F + 1)*2, nil, F, 2, S_NULL}

//Super Wing Thinker
freeslot("MT_CMAN_WING", "SPR_CMN4", "S_CMAN_WING_0", "S_CMAN_WING_1", "S_CMAN_WING_2")
states[S_CMAN_WING_0] = {SPR_NULL, 0, 1, nil, 0, 0, S_CMAN_WING_1}
states[S_CMAN_WING_1] = {SPR_CMN4, A|FF_PAPERSPRITE, -1, nil, 0, 0, S_CMAN_WING_1}
states[S_CMAN_WING_2] = {SPR_CMN4, A|FF_PAPERSPRITE|FF_ANIMATE, (D + 1)*2, nil, D, 2, S_CMAN_WING_1}
mobjinfo[MT_CMAN_WING] = {
	spawnstate = S_CMAN_WING_0,
	spawnhealth = 1000,
	radius = 16*FRACUNIT,
	height = 16*FRACUNIT,
	flags = MF_NOBLOCKMAP|MF_NOGRAVITY|MF_SLIDEME|MF_NOCLIPHEIGHT|MF_SCENERY
}

addHook("MobjThinker", function(mobj)
	if not (mobj.tracer and mobj.tracer.valid and mobj.tracer.player
	and mobj.tracer.skin == "cman" and mobj.tracer.player.powers[pw_super]) then P_KillMobj(mobj) return end
	A_CapeChase(mobj, 1)
	if not (mobj and mobj.valid) then return end
	
	mobj.destscale = mobj.tracer.scale*3/2
	mobj.rollangle = mobj.tracer.rollangle
	mobj.color = mobj.tracer.color
	
	if (mobj.tracer.eflags & MFE_VERTICALFLIP)
		mobj.eflags = $|MFE_VERTICALFLIP
		mobj.flags2 = $|MF2_OBJECTFLIP
	else
		mobj.eflags = $ & ~MFE_VERTICALFLIP
		mobj.flags2 = $ & ~MF2_OBJECTFLIP
	end
	
	if (mobj.tracer.flags2 & MF2_DONTDRAW)
		if not (mobj.flags2 & MF2_DONTDRAW) then mobj.flags2 = $|MF2_DONTDRAW end
	elseif (mobj.flags2 & MF2_DONTDRAW)
		mobj.flags2 = $ & ~MF2_DONTDRAW
	end
	
	if mobj.tracer.state == S_PLAY_TWINSPIN
	and not (mobj.tracer.frame & FF_FRAMEMASK)
		if not mobj.reactiontime
			mobj.reactiontime = 1
			mobj.state = S_CMAN_WING_2
		end
	elseif mobj.reactiontime
		mobj.reactiontime = 0
	end
	
	local angerle = ANGLE_135
	if mobj.threshold > 0 then angerle = ANGLE_225 end
	local heightdiv = 3
	if (mobj.tracer.sprite2 &~ FF_SPR2SUPER == SPR2_ROLL) then heightdiv = 5 end
	P_TeleportMove(mobj, P_ReturnThrustX(nil, mobj.tracer.player.drawangle-angerle, 6*mobj.tracer.scale)+mobj.tracer.x,
	P_ReturnThrustY(nil, mobj.tracer.player.drawangle-angerle, 6*mobj.tracer.scale)+mobj.tracer.y,
	mobj.tracer.z+(mobj.tracer.height/heightdiv))
	if (mobj.tracer.eflags & MFE_VERTICALFLIP) then mobj.z = mobj.tracer.z+mobj.tracer.height-mobj.height-(mobj.tracer.height/heightdiv) end
	mobj.angle = R_PointToAngle2(mobj.x, mobj.y, mobj.tracer.x, mobj.tracer.y)
end, MT_CMAN_WING)

//Color table for the different badniks
//Yea this is just lifted from Skip, but there's no way I'm rewriting this
local cmancolors = {
	[MT_BLUECRAWLA] = SKINCOLOR_AZURE,
	[MT_REDCRAWLA] = SKINCOLOR_RED,
	[MT_GFZFISH] = SKINCOLOR_BLUE,
	[MT_GOLDBUZZ] = SKINCOLOR_GOLD,
	[MT_REDBUZZ] = SKINCOLOR_RED,
	[MT_JETTBOMBER] = SKINCOLOR_APPLE,
	[MT_JETTGUNNER] = SKINCOLOR_GOLD,
	[MT_CRAWLACOMMANDER] = SKINCOLOR_BLUE,
	[MT_DETON] = SKINCOLOR_RED,
	[MT_SKIM] = SKINCOLOR_CLOUDY,
	[MT_TURRET] = SKINCOLOR_DUSK,
	[MT_POPUPTURRET] = SKINCOLOR_GREY,
	[MT_SPINCUSHION] = SKINCOLOR_CERULEAN,
	[MT_CRUSHSTACEAN] = SKINCOLOR_RED,
	[MT_BANPYURA] = SKINCOLOR_AQUA,
	[MT_JETJAW] = SKINCOLOR_ORANGE,
	[MT_SNAILER] = SKINCOLOR_RED,
	[MT_VULTURE] = SKINCOLOR_RED,
	[MT_POINTY] = SKINCOLOR_CERULEAN,
	[MT_ROBOHOOD] = SKINCOLOR_GREEN,
	[MT_FACESTABBER] = SKINCOLOR_RED,
	[MT_EGGGUARD] = SKINCOLOR_LILAC,
	[MT_GSNAPPER] = SKINCOLOR_GREEN,
	[MT_MINUS] = SKINCOLOR_CLOUDY,
	[MT_SPRINGSHELL] = SKINCOLOR_BLUEBELL,
	[MT_YELLOWSHELL] = SKINCOLOR_ORANGE,
	[MT_UNIDUS] = SKINCOLOR_JET,
	[MT_CANARIVORE] = SKINCOLOR_CLOUDY,
	[MT_PYREFLY] = SKINCOLOR_CRIMSON,
	[MT_PTERABYTE] = SKINCOLOR_LILAC,
	[MT_DRAGONBOMBER] = SKINCOLOR_JET,
	[MT_PENGUINATOR] = SKINCOLOR_BLUE,
	[MT_POPHAT] = SKINCOLOR_AETHER,
	[MT_HIVEELEMENTAL] = SKINCOLOR_YELLOW,
	[MT_BUMBLEBORE] = SKINCOLOR_YELLOW,
	[MT_BUGGLE] = SKINCOLOR_AZURE,
	[MT_CACOLANTERN] = SKINCOLOR_ORANGE,
	[MT_SPINBOBERT] = SKINCOLOR_AETHER,
	[MT_HANGSTER] = SKINCOLOR_PURPLE,
	[MT_METALSONIC_BATTLE] = SKINCOLOR_COBALT,
	[MT_BLACKEGGMAN] = SKINCOLOR_BLACK,
	[MT_CYBRAKDEMON] = SKINCOLOR_BLACK,
}

function A_Cman_Garbage(mobj, var1, var2)
	if not mobj.threshold
		mobj.flags = $ | MF_BOUNCE &~ MF_NOGRAVITY &~ MF_NOCLIP &~ MF_NOCLIPHEIGHT &~ MF_SCENERY
		mobj.threshold = P_RandomRange(A, E) + 1
		
		mobj.shadowscale = FRACUNIT/4
	end
	mobj.frame = mobj.threshold - 1
	
	mobj.rollangle = $ - FixedAngle(FixedHypot(R_PointToDist2(0,0, mobj.momx, mobj.momy), mobj.momz))*2
	
	if P_CheckDeathPitCollide(mobj) and not (mobj.flags & MF_NOCLIPHEIGHT)
		mobj.flags = $ | MF_NOCLIPHEIGHT | MF_NOCLIP
		mobj.momz = mobj.lastlook
		mobj.shadowscale = 0
	elseif P_IsObjectOnGround(mobj) and not (mobj.flags & MF_NOCLIPHEIGHT)
		mobj.momz = mobj.lastlook*2/-3
		if abs(mobj.momz) < mobj.scale
			mobj.momz = 0
		end
	else
		if mobj.eflags & MFE_UNDERWATER
			mobj.momz = $ - P_GetMobjGravity(mobj)*5/4
			mobj.momx = $*63/64
			mobj.momy = $*63/64
		end
		mobj.lastlook = mobj.momz
	end
	
	if not mobj.fuse
		mobj.fuse = TICRATE*3
	elseif ((mobj.frame & FF_TRANSMASK) >> FF_TRANSSHIFT) <= (NUMTRANSMAPS-1) - mobj.fuse / 2
		mobj.tics = -1
	end
end

freeslot("S_CMAN_GARBAGE", "SPR_CMN3")
states[S_CMAN_GARBAGE] = {SPR_CMN3, A, 1, A_Cman_Garbage, 0, 0, S_CMAN_GARBAGE}

addHook("MobjDamage", function(mobj, inf, mo)
	if mo and mo.skin == "cman" and cmancolors[mobj.type]
		S_StartSound(mobj, sfx_cmmtl1 + P_RandomKey(2))
		
		for i = 1, 6
			local part = P_SpawnMobjFromMobj(mobj, 0,0,0, MT_GHOST)
			local factor = 4
			
			part.angle = $ + P_RandomRange(0, 360)*ANG1
			P_InstaThrust(part, part.angle, (P_RandomFixed() - INT16_MAX)*factor + FRACUNIT*factor)
			part.momz = P_RandomFixed()*factor + FRACUNIT*factor
			
			part.momx = FixedMul($, part.scale)
			part.momy = FixedMul($, part.scale)
			part.momz = FixedMul($, part.scale)*P_MobjFlip(part)
			part.z = $ + P_MobjFlip(part)
			
			part.color = cmancolors[mobj.type]
			part.state = S_CMAN_GARBAGE
		end
	end
end)

//Can't move conditions
local function CantMove(player)
	local mo = player.mo
	return not (mo and mo.valid and mo.skin == "cman")
	or P_PlayerInPain(player)
	or (player.panim == PA_PAIN and not (player.pflags & PF_JUMPED))
	or player.pflags & PF_SLIDING
	or player.powers[pw_carry]
	or player.spectator
	or player.playerstate
	or not mo.health
	or player.powers[pw_super] == 1
	or player.iseggrobo
	or player.isjettysyn
	or player.guard
	or player.actionstate
	or player.powers[pw_nocontrol]
	or (player.isxmomentum and mo.state == S_PLAY_FACEPLANT)
end

//Break a wall we hit
local function BreakWall(mo, line)
	if not (mo and line) then return end
	
	local linesectors = {line.frontsector, line.backsector}
	for i, sector in ipairs(linesectors)
		if not sector then continue end
		
		for fof in sector.ffloors()
			if fof.valid and (fof.flags & FF_BUSTUP) and (fof.flags & FF_EXISTS)
				local foffloor = fof.topheight
				local fofceiling = fof.bottomheight
				if fof.b_slope and fof.b_slope.valid
					fofceiling = P_GetZAt(fof.b_slope, mo.x, mo.y)
				end
				if fof.t_slope and fof.t_slope.valid
					foffloor = P_GetZAt(fof.t_slope, mo.x, mo.y)
				end
				if foffloor >= mo.z and fofceiling <= mo.z+mo.height
					EV_CrumbleChain(nil, fof)
					if fof.master.flags & ML_EFFECT5
						P_LinedefExecute(P_AproxDistance(fof.master.dx, fof.master.dy)>>FRACBITS, mo, sector)
					end
					return true
				end
			end
		end
	end
end

//Lose dash
local cmanlosedash = function(player, mo)
	if not player.cmandash then return end
	player.cmandash = 0
	
	if not (mo and mo.valid) then return end
	
	//Visual
	S_StartSoundAtVolume(mo, sfx_cmdsmd, 192)
	S_StartSound(mo, sfx_prloop)
	S_StopSoundByID(mo, sfx_cmwind)
	if player == displayplayer or player == secondarydisplayplayer
		P_StartQuake(8*mo.scale, 5)
	end
	
	//Paraloop
	local range = 192*mo.scale
	for d = 0, 15
		P_SpawnParaloop(mo.x, mo.y, mo.z + mo.height, range, 16,
		MT_NIGHTSPARKLE, d*(ANGLE_22h), S_NULL, true)
	end
	
	//Damage
	searchBlockmap("objects", function(refmobj, mobj)
		if FixedHypot(FixedHypot(mo.x - mobj.x, mo.y - mobj.y), mo.z - mobj.z) < range
		and mobj.flags & MF_SHOOTABLE and mobj.health
			P_DamageMobj(mobj, mo, mo)
		end
	end, mo, mo.x-range,mo.x+range,mo.y-range,mo.y+range)
	
	//Crumble
	searchBlockmap("lines", BreakWall,
	mo, mo.x-range,mo.x+range,mo.y-range,mo.y+range)
end

//Reset Cman
local function ResetCman(player)
	cmanlosedash(player, player.mo)
	
	player.cmanprep = 0
	player.cmancloud = 0
	player.cmanlanding = 0
	
	player.cmanwallmomx = nil
	player.cmanwallmomy = nil
	
	player.cmanreset = true
end
addHook("PlayerSpawn", ResetCman)
for player in players.iterate ResetCman(player) end

//Spawns objects in a circle
local cmancircle = function(mo, mobjtype, amount, ns, zoffset, scale, keepmom, color, vertical, vertangle)
	if not amount then return end
	if vertangle == nil
		vertangle = mo.player and mo.player.drawangle or mo.angle
	end
	
	local i = 0	while i < amount
		local fa = i*(ANGLE_180/(amount/2)) + (vertangle or 0)
		local mobj = P_SpawnMobjFromMobj(mo,0,0,zoffset,mobjtype)
		if mobj and mobj.valid
			local height = mobj.height
			mobj.scale = scale
			
			if mobj.flags & MF_MISSILE
				mobj.target = mo
			end
			if mobjtype == MT_MINECARTSPARK
				mobj.fuse = TICRATE/2
			end
			if mo.eflags&MFE_VERTICALFLIP
				mobj.z = $ - (mobj.height-height)
			end
			
			if color
				mobj.color = color
				if mobjtype != MT_GHOST
					mobj.colorized = true
				end
			end
			
			if vertical
				mobj.momz = FixedMul(sin(fa),ns)
				P_InstaThrust(mobj, vertangle+ANGLE_90,
				FixedMul(cos(fa),ns))
			else
				mobj.momx = FixedMul(cos(fa),ns)
				mobj.momy = FixedMul(sin(fa),ns)
				mobj.angle = fa
			end
			
			if keepmom == -1
				mobj.momx = $ + mo.momx*2/3
				mobj.momy = $ + mo.momy*2/3
				mobj.momz = $ + P_GetMobjGravity(mo)*8
			elseif keepmom
				if keepmom == true then keepmom = 1 end
				mobj.momx = $ + mo.momx/keepmom
				mobj.momy = $ + mo.momy/keepmom
				mobj.momz = $ + mo.momz/keepmom
			end
			
			if mobj.type == MT_GHOST
				mobj.momx = $ + P_RandomRange(-24, 24)*mobj.scale/6
				mobj.momy = $ + P_RandomRange(-24, 24)*mobj.scale/6
				mobj.momz = $ + P_RandomRange(2, 24)*mobj.scale/3
				if not vertical P_SetObjectMomZ(mobj, 4*FRACUNIT, true) end
			end
		end
		i = $ + 1
	end
end

//Dash move
addHook("SpinSpecial", function(player)
	local mo = player.mo
	if CantMove(player)
	or player.pflags & (PF_STASIS|PF_SPINDOWN)
	or player.exiting
	or player.airdodge
	or player.cmanprep
	or (player.glidetime > 1 and not player.powers[pw_super])
	or not (P_IsObjectOnGround(mo) or player.pflags & PF_JUMPED)
	then return end
	
	local thok = P_SpawnMobjFromMobj(mo, 0,0,0, MT_THOK)
	thok.scale = $*2
	
	thok.target = mo
	A_CapeChase(thok)
	
	P_TeleportMove(thok, thok.x + mo.momx, thok.y + mo.momy, thok.z + mo.momz)
	A_CanarivoreGas(thok, MT_BOXSPARKLE)
	
	P_RemoveMobj(thok)
	
	cmanlosedash(player, mo)
	if not P_IsObjectOnGround(mo)
		if player.glidetime
			player.pflags = $ | PF_THOKKED
		end
		player.glidetime = $ + 2
	end
	
	player.cmanprep = PREPTIME
	mo.state = S_PLAY_SPINDASH
	S_StartSound(mo, sfx_cmprep)
	player.cmansquish = -SQUISHTIME
end)

//Hit a wall
local function HitWall(mo)
	local player = mo.player
	if not player then return end
	
	if player.cmanwallmomx != nil and player.cmanwallmomy != nil
		mo.momx = player.cmanwallmomx
		mo.momy = player.cmanwallmomy
	end
	
	S_StartSound(mo, sfx_s3k5f)
	cmanlosedash(player, mo)
	
	P_InstaThrust(mo, R_PointToAngle2(0,0, mo.momx, mo.momy), mo.radius)
	mo.momz = 0
	
	mo.state = S_PLAY_PAIN
	mo.sprite2 = SPR2_STUN
end

//Hit wall during dash
addHook("MobjMoveBlocked", function(mo, mobj, line)
	local player = mo.player
	if not player or CantMove(player) or not player.cmandash or not player.speed
		return
	end
	
	local oldmomx = mo.momx
	local oldmomy = mo.momy
	P_BounceMove(mo)
	
	if mobj
		if mobj.flags & MF_MONITOR
		or mobj.type == MT_SPIKE or mobj.type == MT_WALLSPIKE
			P_KillMobj(mobj, mo, mo)
		end
		HitWall(mo)
	elseif BreakWall(mo, line)
		HitWall(mo)
	else
		player.cmanwallmomx = mo.momx
		player.cmanwallmomy = mo.momy
		
		mo.momx = oldmomx
		mo.momy = oldmomy
	end
end, MT_PLAYER)

//Double jump and Cloud move
addHook("AbilitySpecial", function(player)
	local mo = player.mo
	if not (mo and mo.skin == "cman") then return end
	if (player.pflags & PF_THOKKED and not player.powers[pw_super]) then return end
	
	if not player.cmandash
		player.secondjump = $ + 1
		player.pflags = $ &~ PF_JUMPED | PF_THOKKED
		P_DoJump(player, not player.powers[pw_super])
		
		if player.powers[pw_super]
			S_StartSound(mo, sfx_s1ab)
		end
		player.cmansquish = SQUISHTIME
		
		mo.state = S_PLAY_TWINSPIN
		cmancircle(mo, mo.eflags & MFE_UNDERWATER and MT_SMALLBUBBLE or MT_DUST,
		8, 4*mo.scale, 0, mo.scale, 2)
		
		return true
	end
	
	S_StartSound(mo, sfx_cmcld1)
	cmanlosedash(player, mo)
	
	mo.momx = $/2
	mo.momy = $/2
	mo.momz = P_GetMobjGravity(mo)*CLOUDTIME
	
	player.cmancloud = CLOUDTIME
	player.cmansquish = -SQUISHTIME
	player.glidetime = $ + 1
	
	player.cmanplatform = P_SpawnGhostMobj(mo)
	player.cmanplatform.sprite = SPR_CMN2
	player.cmanplatform.frame = G
	player.cmanplatform.fuse = player.cmancloud*2
	
	return true
end)

addHook("PlayerCanDamage", function(player)
	if player.mo and player.mo.skin == "cman"
	and player.mo.state == S_PLAY_TWINSPIN
		return true
	end
end)

//Main thinker
addHook("PlayerThink", function(player)
	local mo = player.mo
	
	//Squishy
	if mo and mo.valid
		if player.cmansquish
			if player.cmansquish > 0
				player.cmansquish = $ - 1
			else
				player.cmansquish = $ + 1
			end
			local factor = 4
			if abs(player.cmansquish) <= SQUISHTIME/3 then factor = $*4
			elseif abs(player.cmansquish) <= SQUISHTIME*2/3 then factor = $*2 end
			mo.spritexscale = FRACUNIT - sin(player.cmansquish*ANGLE_45)/factor
			mo.spriteyscale = FRACUNIT + sin(player.cmansquish*ANGLE_45)/factor
		end
			
		if mo.skin == "cman" and not P_IsObjectOnGround(mo)
			local momz = min(mo.momz*P_MobjFlip(mo), 0)
			if player.cmansquish
				mo.spritexscale = $ + FixedDiv(momz/UINT8_MAX, mo.scale)
				mo.spriteyscale = $ - FixedDiv(momz/UINT8_MAX, mo.scale)
			else
				mo.spritexscale = FRACUNIT + FixedDiv(momz/UINT8_MAX, mo.scale)
				mo.spriteyscale = FRACUNIT - FixedDiv(momz/UINT8_MAX, mo.scale)
				player.cmansquish = nil
			end
		elseif player.cmansquish == nil
			player.cmansquish = 0
			mo.spritexscale = FRACUNIT
			mo.spriteyscale = FRACUNIT
		end
	end
	
	//Prevent the rest of the code
	if CantMove(player)
		if not player.cmanreset
			ResetCman(player)
		end
		return
	end
	player.cmanreset = false
	
	//Jump squish
	if mo.state == S_PLAY_JUMP
	and player.pflags & PF_STARTJUMP and player.pflags & PF_JUMPED
	and not (player.pflags & (PF_THOKKED|PF_SHIELDABILITY))
	and mo.momz*P_MobjFlip(mo) >= 0
		player.cmansquish = SQUISHTIME
		mo.state = S_PLAY_SPRING
		player.panim = PA_JUMP
		mo.tics = -1
	end
	
	//Landing squish
	if not (P_IsObjectOnGround(mo) or mo.eflags & MFE_JUSTHITFLOOR)
		player.cmanlanding = $ + 1
	elseif player.cmanlanding
		if player.cmanlanding >= 5
			player.cmansquish = SQUISHTIME
		end
		player.cmanlanding = 0
	end
	
	//Super Wing Spawner
	if player.powers[pw_super]
	and not (player.cmanwing1 and player.cmanwing1.valid)
		player.cmanwing1 = P_SpawnMobjFromMobj(player.mo, 0,0,0, MT_CMAN_WING)
		player.cmanwing1.tracer = player.mo
		player.cmanwing1.threshold = 0
		player.cmanwing2 = P_SpawnMobjFromMobj(player.mo, 0,0,0, MT_CMAN_WING)
		player.cmanwing2.tracer = player.mo
		player.cmanwing2.threshold = 1
	end
	
	//Hit wall
	if player.cmanwallmomx != nil and player.cmanwallmomy != nil
		if not player.powers[pw_justlaunched]
		and FixedHypot(player.cmanwallmomx, player.cmanwallmomy)*2/3 > player.speed
			HitWall(mo)
		elseif player.powers[pw_justlaunched] == 2
			cmanlosedash(player, mo)
		end
		player.cmanwallmomx = nil
		player.cmanwallmomy = nil
	end
	
	//Prep for dash
	if player.cmanprep
		player.cmanprep = $ - 1
		
		if player.cmanprep
			local div1 = PREPTIME
			local div2 = div1 - 1
			
			if P_IsObjectOnGround(mo)
				div1 = $/2
				div2 = div1 - 1
			else
				mo.momz = ($ - P_GetMobjGravity(mo))*div2/div1
			end
			
			mo.momx = $*div2/div1
			mo.momy = $*div2/div1
			
			mo.state = S_PLAY_SPINDASH
			
		//Start dash
		else
			if not player.speed and not player.cmd.forwardmove and not player.cmd.sidemove
				player.cmd.forwardmove = 1
			end
			
			local actionspd = FixedMul(player.actionspd, mo.scale)
			if mo.eflags & MFE_UNDERWATER then actionspd = $/2 end
			
			player.drawangle = mo.angle
			P_InstaThrust(mo, player.drawangle, actionspd)
			S_StartSound(mo, sfx_cmdash)
			player.cmansquish = -SQUISHTIME
			
			player.cmandash = 1
			mo.state = P_IsObjectOnGround(mo) and S_PLAY_RUN or S_PLAY_GLIDE
			player.skidtime = 0
			
			local thok = P_SpawnMobjFromMobj(mo, 0,0,0, MT_THOK)
			thok.state = S_CMAN_PARTICLE2
			thok.color = mo.color
		end
	end
	
	//Dashing
	if player.cmandash
		player.cmandash = $ + 1
		
		if player.skidtime or player.panim == PA_SPRING
		or FixedHypot(mo.momx, mo.momy) < FixedMul(player.runspeed, mo.scale)
			cmanlosedash(player, mo)
		else
			mo.friction = FRACUNIT - INT8_MAX
			player.powers[pw_sneakers] = max($, 2)
			player.powers[pw_noautobrake] = max($, 2)
			
			A_BossScream(mo, 0, mo.eflags & MFE_UNDERWATER and MT_SMALLBUBBLE or MT_DUST)
			A_BossScream(mo, 0, MT_BOXSPARKLE)
			
			if not ((player.cmandash - 2) % 94)
				S_StartSound(mo, sfx_cmwind)
			end
		end
	end
	
	//Cloud
	if player.cmancloud
		player.cmancloud = $ - 1
		player.glidetime = max($, 1)
		
		if player.cmancloud
			mo.momz = $ - P_GetMobjGravity(mo)*2
			mo.state = S_PLAY_GLIDE_LANDING
			
			A_CanarivoreGas(mo, MT_DUST)
		else
			player.pflags = $ &~ PF_JUMPED
			P_DoJump(player, false)
			mo.state = S_PLAY_FLY
			
			mo.momz = $*2
			S_StartSound(mo, sfx_cmcld2)
			player.cmansquish = SQUISHTIME
		end
	end
end)

//Extra object effects
addHook("PostThinkFrame", do for player in players.iterate
	local mo = player.mo
	if CantMove(player) then continue end
	
	//Cloud
	if player.cmancloud and player.cmanplatform and player.cmanplatform.valid
		A_CapeChase(player.cmanplatform)
		
		player.cmanplatform.momx = mo.momx/2
		player.cmanplatform.momy = mo.momy/2
		player.cmanplatform.momz = mo.momz/-2
	end
			
	//Running
	if player.cmandash and player.panim == PA_RUN and P_IsObjectOnGround(mo)
		for i = -1, 1
			if not i continue end
			
			local thok = P_SpawnMobjFromMobj(mo, 0,0,0, MT_THOK)
			thok.flags2 = $ | MF2_BOSSNOTRAP
			thok.fuse = 2
			
			thok.spritexscale = FRACUNIT*3/2
			
			thok.color = SKINCOLOR_AETHER + abs( ( (player.cmandash / 2) % 9) - 4)
			if thok.color == SKINCOLOR_PINK then thok.color = SKINCOLOR_AZURE
			elseif thok.color == SKINCOLOR_YOGURT then thok.color = SKINCOLOR_DUSK end
			
			thok.sprite = SPR_CMN1
			thok.frame = ((player.cmandash/2) % 3) | FF_PAPERSPRITE
			
			thok.angle = R_PointToAngle2(0,0, mo.momx, mo.momy)
			P_TeleportMove(thok,
			thok.x + P_ReturnThrustX(mo, thok.angle, mo.scale)
			+ P_ReturnThrustX(mo, thok.angle + ANGLE_90, mo.radius*2/3*i),
			thok.y + P_ReturnThrustY(mo, thok.angle, mo.scale)
			+ P_ReturnThrustY(mo, thok.angle + ANGLE_90, mo.radius*2/3*i),
			thok.z)
			
			thok.angle = $ - ANGLE_22h*i
		end
		
		if (mo.frame & FF_FRAMEMASK) & 1 and mo.tics == 1
			P_SpawnSkidDust(player, mo.radius)
		end
	end
end end)